#!/usr/bin/perl

###############################################################################
#	SKT Memo Note

###############################################################################
# Convert 99.09.25 SKT From SEPAL'S SKETCHBOOK MEMO V1.2 
# Add     99.09.28 SKT Gradiant Table
# Modify  99.10.03 SKT Resize Height And Width
###############################################################################
require "admin.cgi";
&Read_Config;
&Initial_Memo;
&Read_Cookie;
&getDate;

if($ENV{'QUERY_STRING'}) {
	@pairs = split(/&/,$ENV{'QUERY_STRING'});
	foreach $pair (@pairs) {
		($name, $value) = split(/=/,$pair);
		$value =~ tr/+/ /;
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
		$in{$name} = $value;
	}
}
else {
	$content_type = $ENV{'CONTENT_TYPE'};
	$content_length = $ENV{'CONTENT_LENGTH'};
	read(STDIN,$buffer,$content_length);
	if((!$content_type) || ($content_type eq 'application/x-www-form-urlencoded')) {
		@pairs = split(/&/, $buffer);

		foreach $pair (@pairs) {
			($name, $value) = split(/=/,$pair);
			$value =~ tr/+/ /;
			$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
			$in{$name} = $value;
		}
	}
	else {
		print "Invalid content type!\n";
		exit(1);
	}
}

&getNumber;

unless($in{'action'}) {
	$in{'action'} = "r";
}

if($in{'action'} eq "r") {	
	&readData;
} 
elsif($in{'action'} eq "write") {
	&writeData;
} 
elsif($in{'action'} eq "admin") {
	&Admin;
} 
elsif($in{'action'} eq "") {
	&Save;
} 
else {
	exit;
}

sub getNumber {
	open(HANDLE,"<$main_dir/num.txt");
	$no_of_data = <HANDLE>;
	close(HANDLE);
	chop($no_of_data);
}

sub readData {
    if($in{'p'}) {
        $cur_page = $in{'p'};
    }
    else {
        $cur_page = "1";
    }

    $tot_page = int(($no_of_data-1)/$per_page)+1;

    &htmlHead;
    &formMemo;
    &readMemo;
    &htmlFoot;
}

sub htmlHead {

print "Content-type: text/html\n\n";

print <<HTMLHEAD;
<!--------------------------------------
     SKT2000 ZONE Main Page
	 Last Modified 99.10.29
	 Source : Sepal Memo
	 Modify : SKT
---------------------------------------->
<html>
<head>
<title>Welcome To SKT2000 Zone</title>
<style type='text/css'>
<!--
A:link {color:blue;text-decoration:none;}
A:visited {color:blue;text-decoration:none;}
A:active {color:red;text-decoration:underline;}
A:hover {text-decoration:underline;}
-->
.t {line-height:1.4}
BODY,TD,SELECT,input,DIV,form,TEXTAREA {font-size:10pt;}
P,blockquote,td,br {font-size:10pt}
-->
</style>
<script language="JavaScript">
function nextWin(){
	location = "$cgi_url#޸"
}
function clearField(field){
   if (field.value == field.defaultValue) {
     field.value = "";
   }
 }
function checkField(field){
    if (field.value == "") {
    field.value = field.defaultValue;
 }
 }
</script>
</head>
HTMLHEAD

if($in{'action'} eq "write") {
print "<body bgcolor=#F2F2FF onLoad=\"setTimeout(\'nextWin()\',0)\" >\n";
}
else{
print "<body bgcolor=#F2F2FF>\n";
}

#޸ κ...
print <<UPMEMO;
<body bgcolor="#CCFFFF" text="black" link="blue" vlink="purple" alink="red">

UPMEMO
}

sub htmlFoot {

#޸ Ʒκ...
print <<DOWNMEMO;

</body>
</html>
DOWNMEMO

	exit;
}

sub Read_Cookie{
    
    if($ENV{'HTTP_COOKIE'}) {
        @cookies = split(/; /,$ENV{'HTTP_COOKIE'});
        foreach(@cookies) {
            ($name,$value) = split(/=/,$_);
            $COOKIE{$name} = $value;
        }
    }
}

sub formMemo {
	$G=0;

	print qq(
	<a name=޸></a>
	<form method=post action=$cgi_url><div align="center">
	<table border cellpadding="0" cellspacing="0"  bordercolorlight="$B_Color">
    <tr>
        <td width="545" height="30" align="center" bgcolor="$T_BgColor">
		<p align="center" style="margin-left:10px;"><font size="3" color="$T_TxColor"><b>
		<img src="images/bull.gif" border="0">&nbsp;
	);
	if($in{'comment'} eq ""){
		if ($TimeInsa == 0) {
			print $Title;
		}
		else{
			&insa;
		}
	}
	else{
		print " <font color=orange>$in{'name'}</font> <font color=$T_TxColor>$Thanks</font>";
	}
	print qq(
		&nbsp;
		<img src="images/bull.gif" border="0"></b></font></td>
    </tr>
    <tr>
        <td width="545" align="left" bgcolor="$T_BgColor">
		<div align="center"><table border="0" cellpadding="0" cellspacing="0" width="547">
        <tr>
	);


#  Gradian ȿ Ÿ Table
	for($G=0;$G<=4;$G++){
 	 print "<td width=3 rowspan=12 bgcolor=$Grad_color[$G]><p>&nbsp;</td>";
	}
	print qq (
		<td width="473" height="36" align="left" colspan="2" bgcolor="$Grad_color[4]">
		<p align="center"><font size="2" color="$Text_Color"≯
		<input type=hidden name="action" value="write">
		<input type=hidden name="p" value="1">
		<input type=hidden name="page" value="1">
		<input type="text" name="name" value="$COOKIE{'WHO'}" maxlength="20" size="10" onblur="checkField(this)" onfocus="clearField(this)">
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;޸
		<input name=comment type=text size=27 value="$MemoTxt" maxlength=60 onblur="checkField(this)" onfocus="clearField(this)"> 
		&nbsp;&nbsp;&nbsp;&nbsp;
		<input type=submit value= style="border-width:1px; border-color:rgb(204,204,204); border-style:solid; height:20px;">
		</font></td>
	);



#  Gradian ȿ Ÿ Table
	$i =0;
	for($i=0,$G=4;$i<=4;$i++,$G--){
 		print "<td width=3 rowspan=12 bgcolor=$Grad_color[$G]><p>&nbsp;</td>";
	}
	print "</tr>";

}

sub readMemo {
    open(HANDLE,"$main_dir/memo.txt");
        @datum = <HANDLE>;
    close(HANDLE);   

	$k=0;
# memo о Table  ش.
	for($i=($cur_page-1)*$per_page+1;$i<=($cur_page-1)*$per_page+$per_page;$i++) {  		
  		@value = split(/\|/,$datum[$i]);    
        $actual_number = ($no_of_data+1)-$i;
        if($actual_number > 0) {
            $date=$value[2];
			print qq(
			   <tr>
                    <td width="109" bgcolor="$Memo_BgColor" algin="left">
					<p style="margin-left:0;">
					<font size="2" color=$text_color[$k]>$date&nbsp;</font>
					</td>
                    <td bgcolor="$Memo_BgColor" algin="left">
					<p style="margin-left:0;">
					<font size="2" color=$text_color[$k]>[$value[1]]..$value[3]</font>
					</td>
                </tr>
			);
        $k++;
		}
    }
# ޸ ϴ ũ ڿ (ð λ縻 ص...)
	print qq(
          <tr>
			<td width="473" height=15 align="left" colspan="2" bgcolor="$Grad_color[4]">
			<p align="center" style="margin-right:10; margin-left:10;">
			<font color="$Scrol_Color"><marquee>$Scroll_Text</marquee></font></td>
		   </tr>
       </table></div></td>
    </tr>
	);
	print qq(
    <tr>
        <td width="545" height="33" align="left" bgcolor="$T_BgColor">
		<p align="center" style="margin-left:10;">
		<a href=admin.html>Admin</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
		<font size="2" color="blue">
	);

###################################[ quick number start ]#####################################
$first = 1; 
$last = $list_num;
while ($first <= $tot_page) {
	if (($first <= $cur_page) && ($cur_page <= $last)) {
		$prevp = $first - 1;

		if ($prevp > 0) {
			print "[<a href=$cgi_url?action=r&p=$prevp#޸><font color=blue>Prev</font></a>].....";
		}
		else {
			print "[Prev].....";
		}
		if ($last <= $tot_page) {
			for ($page = $first; $page <= $last; $page++) {
				if ($page == $cur_page) {
					print "[<font color=red><b>$page</b></font>]";
				}
				else {
					print "<a href=$cgi_url?action=r&p=$page#޸>[$page]</a>";
				}
			}
		}
		else {
			for ($page = $first; $page <= $tot_page; $page++) {
				if ($page == $cur_page) {
					print "[<font color=red><b>$page</b></font>]";
				}
				else {
					print "<a href=$cgi_url?action=r&p=$page#޸>[$page]</a>";
				}
			}
		}
		$nextp = $last + 1;
  		if ($nextp <= $tot_page) {
			print ".....[<a href=$cgi_url?action=r&p=$nextp#޸><font color=blue>Next</font></a>]";
		}
		else {
			print ".....[Next]";
		}    
	}
		$first = $first + $list_num;
		$last = $last + $list_num;
	}

	print qq(
			&nbsp;&nbsp;&nbsp;<a href=$cgi_url?action=r&p=1>Refresh</a>
			</td>
	    </tr>
	</table></div>
	</form>
	);


}
###################################[ quick number end ]###################################

sub putNumber {
    open(HANDLE,">$main_dir/num.txt");
    print HANDLE "$no_of_data\n";
    close(HANDLE);
}

sub writeData {
    &getNumber;
	&getVariable;
	&writeMemofile;
    if($no_of_data < $total_num){
		$no_of_data++;
	}
	else{
		$no_of_data=$total_num;
	}
    &putNumber;
	&readData
}

sub getVariable {
    unless($in{'name'} =~ /^\s*$/) {
        $name = "$in{'name'}";
        $name =~ s/\|/&#124;/g;
    }
    else {
         &readData; 
    }
    print "Set-Cookie: WHO=$name; expires=Sunday, 12-Dec-1999 12:12:12 GMT;\r\n";
	if($in{'comment'}) {
        $comment = "$in{'comment'}";
        if($html_ok ne "1") { 
            $comment =~ s/</&lt;/g;
            $comment =~ s/>/&gt;/g;
            $comment =~ s/"/&quot;/g;
            $comment =~ s/\|/&#124;/g;
        }
        $comment =~ s/\r\n\r\n/<p>/g;
        $comment =~ s/\r\n/<br>/g;
    }
    else {
        &readData;
    }
}

sub getDate {     
    @week = ("", "", "", "", "", "", "");
    ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);

    $word_0="";
	if($min < 10) {
        $min = "0$min";
    }
    if($hour < 10) {
        $hour = "0$hour";
    }
    $mon++;
    if($mon < 10) {
        $mon = "0$mon";
    }
    if($mday < 10) {
        $mday = "0$mday";
    }

    $write_date = "$mon/$mday($week[$wday]) $hour:$min";
}  

sub insa{
	print $hour==0 ? $word00:
		  $hour==1 ? $word01:
		  $hour==2 ? $word02:
		  $hour==3 ? $word03:
		  $hour==4 ? $word04:
		  $hour==5 ? $word05:
		  $hour==6 ? $word06:
		  $hour==7 ? $word07:
		  $hour==8 ? $word08:
		  $hour==9 ? $word09:
		  $hour==10 ? $word10:
		  $hour==11 ? $word11:
		  $hour==12 ? $word12:
		  $hour==13 ? $word13:
		  $hour==14 ? $word14:
		  $hour==15 ? $word15:
		  $hour==16 ? $word16:
		  $hour==17 ? $word17:
		  $hour==18 ? $word18:
		  $hour==19 ? $word19:
		  $hour==20 ? $word20:
		  $hour==21 ? $word21:
		  $hour==22 ? $word22:
		  $hour==23 ? $word23:"\n";
}

sub writeMemofile {
    local($data);
    local(@datum);

    open(HANDLE,"$main_dir/memo.txt");
    @datum = <HANDLE>;
    close(HANDLE);

	open(HANDLE,">$main_dir/memo.txt");
	for($i=0;$i<$total_num;$i++){
        if($datum[$i] =~ /<!--EOF-->/) {
		    print HANDLE "<!--EOF-->\n";
			print HANDLE "|$name|$write_date|$comment|\n";
        }
        else {
	        print HANDLE "$datum[$i]";
        }
    }
    close(HANDLE);
}

sub Initial_Memo{
###########################[ ؾ  κ ]################################
$main_dir = $Config[2];		#".";#޸ 丮  
$cgi_url =$Config[3];		#cgi ִ URL
$img_url = $Config[4];      #gif ִ URL
$html_ok = $Config[5];      #html ױ   (Ҷ "yes")
$total_num = $Config[6];    #ִ ޸  
$per_page = 10;				#޸  Ÿ ޸ 
$list_num = $Config[7];		#Ʈ ([PREV].....[1][2][3][4][5].....[NEXT])
$table_width = 600;			#޸ ̺ 
$MemoTxt =$Config[8];		# ޸ Ÿ ..
$Title =$Config[9];			# Memo 
$Scroll_Text =$Config[10];	#SKT  Memo ϴܿ Scroll Ǵ ڿ
$T_TxColor = $Config[11];	#  
$T_BgColor = $Config[12];	#  
$B_Color = $Config[13];		#̺
$Memo_BgColor = $Config[14];#޸  
$Text_Color = $Config[15];	#̸ / ޸  
$Scrol_Color = $Config[16];	#帣  

#########################¿ Gradiant ȿ  Color #####################
@Grad_color = (
"$Config[17]","$Config[18]","$Config[19]","$Config[20]","$Config[21]"
);

##############################[ ڻ  ]###################################
@text_color = ( # Խù  10 Ͽϴ.
"$Config[22]","$Config[23]","$Config[24]","$Config[25]","$Config[26]",
"$Config[27]","$Config[28]","$Config[29]","$Config[30]","$Config[31]"
);                       

################################################################################
$TimeInsa = "$Config[32]";	# ٿ ð λ縻  ...

$Thanks = "$Config[33]";	#޸   ϴ ޼
$word00 = "$Config[34]";
$word01 = "$Config[35]";
$word02 = "$Config[36]";
$word03 = "$Config[37]";
$word04 = "$Config[38]";
$word05 = "$Config[39]";
$word06 = "$Config[40]";
$word07 = "$Config[41]";
$word08 = "$Config[42]";
$word09 = "$Config[43]";
$word10 = "$Config[44]";
$word11 = "$Config[45]";
$word12 = "$Config[46]";
$word13 = "$Config[47]";
$word14 = "$Config[48]";
$word15 = "$Config[49]";
$word16 = "$Config[50]";
$word17 = "$Config[51]";
$word18 = "$Config[52]";
$word19 = "$Config[53]";
$word20 = "$Config[54]";
$word21 = "$Config[55]";
$word22 = "$Config[56]";
$word23 = "$Config[57]";
}